'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                 Asleep                                   |
'|                          BassBox OpenGL plugin                           |
'|                                                                          |
'|                              Version 1.00                                |
'|                                                                          |
'|               Transposition of the WinLIFT Asleep project.               |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                            copyright(c) 2010                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-24-2010 (MM-DD-YYYY)            |
'|                        Last revised : 11-03-2010 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
'
#COMPILE DLL "Asleep.dll"
#INCLUDE "Include\BBPlugin.inc"

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG

' -- For V-Sync control we need to get address of extensions
DECLARE FUNCTION wglGetProcAddress LIB "opengl32.dll" ALIAS "wglGetProcAddress" (lpStr AS ASCIIZ) AS LONG

' Key State Masks for Mouse Messages
%MK_LBUTTON                     = &H0001
%MK_RBUTTON                     = &H0002
%MK_SHIFT                       = &H0004
%MK_CONTROL                     = &H0008
%MK_MBUTTON                     = &H0010
%MK_XBUTTON1                    = &H0020
%MK_XBUTTON2                    = &H0040

%WM_MOUSEMOVE                   = &H200
%WM_LBUTTONDOWN                 = &H201
%WM_LBUTTONUP                   = &H202
%WM_LBUTTONDBLCLK               = &H203
%WM_RBUTTONDOWN                 = &H204
%WM_RBUTTONUP                   = &H205
%WM_RBUTTONDBLCLK               = &H206
%WM_MBUTTONDOWN                 = &H207
%WM_MBUTTONUP                   = &H208
%WM_MBUTTONDBLCLK               = &H209
%WM_MOUSEWHEEL                  = &H20A
%WM_XBUTTONDOWN                 = &H20B
%WM_XBUTTONUP                   = &H20C
%WM_XBUTTONDBLCLK               = &H20D

%GL_UNSIGNED_BYTE               = &h1401&
%GL_QUADS                       = &h0007&
%GL_COLOR_BUFFER_BIT            = &h4000&
%GL_DEPTH_BUFFER_BIT            = &h0100&
%GL_MATRIX_MODE                 = &h0BA0&
%GL_MODELVIEW                   = &h1700&
%GL_PROJECTION                  = &h1701&
%GL_SMOOTH                      = &h1D01&
%GL_DEPTH_TEST                  = &h0B71&
%GL_SRC_ALPHA                   = &h0302&
%GL_ONE                         = &h0001&
%GL_BLEND                       = &h0BE2&
%GL_LINEAR                      = &h2601&
%GL_PERSPECTIVE_CORRECTION_HINT = &h0C50&
%GL_NICEST                      = &h1102&
%GL_TEXTURE_2D                  = &h0DE1&
%GL_TEXTURE_MAG_FILTER          = &h2800&
%GL_TEXTURE_MIN_FILTER          = &h2801&
%GL_LUMINANCE                   = &h1909&
%GL_RGB                         = &H1907
%GL_RGBA                        = &H1908
%GL_TEXTURE                     = &H1702
%GL_LESS                        = &H0201
%GL_LIGHTING                    = &H0B50
%GL_GREATER                     = &H0204
%GL_LEQUAL                      = &H0203
%GL_COMPILE                     = &H1300
%GL_TRIANGLE_STRIP              = &H0005
%GL_POINTS                      = &H0000
%GL_LINES                       = &H0001???

%GL_LIGHT0                      = &H4000???
%GL_COLOR_MATERIAL              = &H0B57???

%GL_POINT_SPRITE                = &H08861
%GL_COORD_REPLACE               = &H08862

%GL_ONE_MINUS_SRC_ALPHA         = &H0303
%GL_TRUE                        = 1
%GL_LIGHT_MODEL_LOCAL_VIEWER    = &H0B51???
%GL_NORMALIZE                   = &H0BA1???
%GL_TRIANGLES                   = &H0004???
%GL_TRIANGLE_STRIP              = &H0005???

DECLARE FUNCTION gluNewQuadric  LIB "glu32.dll" ALIAS "gluNewQuadric"  () AS DWORD
DECLARE SUB gluDeleteQuadric    LIB "glu32.dll" ALIAS "gluDeleteQuadric"   (BYVAL state AS DWORD)
DECLARE SUB gluQuadricNormals   LIB "glu32.dll" ALIAS "gluQuadricNormals"  (BYVAL quadObject AS DWORD, BYVAL normals AS DWORD)
DECLARE SUB gluQuadricTexture   LIB "glu32.dll" ALIAS "gluQuadricTexture"  (BYVAL quadObject AS DWORD, BYVAL textureCoords AS DWORD)' ANY)
DECLARE SUB gluSphere      LIB "glu32.dll" ALIAS "gluSphere" (BYVAL qobj AS DWORD, BYVAL radius#, BYVAL slices&, BYVAL stacks AS LONG)
%GLU_SMOOTH                     = 100000

DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd"
DECLARE SUB glPushMatrix LIB "opengl32.dll" ALIAS "glPushMatrix"
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity"
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL LONG)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL DWORD)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL DWORD)
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL DOUBLE)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL DWORD)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL DWORD)
DECLARE SUB glHint LIB "opengl32.dll" ALIAS "glHint" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL LONG, BYVAL LONG)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTexEnvi LIB "opengl32.dll" ALIAS "glTexEnvi" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glColor3f LIB "opengl32.dll" ALIAS "glColor3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glFrustum LIB "opengl32.dll" ALIAS "glFrustum" (BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE)
DECLARE SUB glColor4f LIB "opengl32.dll" ALIAS "glColor4f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glViewport LIB "opengl32.dll" ALIAS "glViewport" (BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL DWORD, textures AS ANY)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL DWORD, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL DWORD, BYVAL DWORD, npixels AS ANY)
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL LONG, textures AS ANY)
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
DECLARE SUB glRotatef LIB "OPENGL32.DLL" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glDepthFunc LIB "OPENGL32.DLL" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glAlphaFunc LIB "OPENGL32.DLL" ALIAS "glAlphaFunc" (BYVAL func AS DWORD, BYVAL ref AS SINGLE)
DECLARE SUB glCallList LIB "opengl32.dll" ALIAS "glCallList" (BYVAL list AS DWORD)
DECLARE SUB glNewList LIB "opengl32.dll" ALIAS "glNewList" (BYVAL list AS DWORD, BYVAL mode AS DWORD)
DECLARE SUB glEndList LIB "opengl32.dll" ALIAS "glEndList" ()
DECLARE SUB glColor4ub LIB "OPENGL32.DLL" ALIAS "glColor4ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE, BYVAL alpha AS BYTE)
DECLARE SUB glPointSize LIB "opengl32.dll" ALIAS "glPointSize" (BYVAL lsize AS SINGLE)
DECLARE SUB glLineWidth LIB "OPENGL32.DLL" ALIAS "glLineWidth" (BYVAL nWidth AS SINGLE)
DECLARE SUB glFlush LIB "OPENGL32.DLL" ALIAS "glFlush" ()
DECLARE FUNCTION glGenLists LIB "opengl32.dll" ALIAS "glGenLists" (BYVAL range&) AS DWORD
DECLARE SUB glMultMatrixf LIB "OPENGL32.DLL" ALIAS "glMultMatrixf" (BYREF m AS SINGLE)
DECLARE SUB glLightModeli LIB "OPENGL32.DLL" ALIAS "glLightModeli" (BYVAL pname AS DWORD, BYVAL param AS LONG)
DECLARE SUB glColor3fv LIB "OPENGL32.DLL" ALIAS "glColor3fv" (BYREF v AS SINGLE)

DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD

DECLARE SUB glScalef LIB "OPENGL32.DLL" ALIAS "glScalef" ( BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glNormal3f LIB "OPENGL32.DLL" ALIAS "glNormal3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)

' -- Advanced feature to keep vertical sync on
DECLARE FUNCTION prototype_wglSwapIntervalEXT( BYVAL number AS LONG ) AS LONG

DECLARE SUB MoveMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" (BYREF Dest AS ANY, BYREF Srce AS ANY, BYVAL Length AS DWORD)

GLOBAL mt() AS BBPTEXTURE
GLOBAL gsR(), gsG(), gsB() AS SINGLE
GLOBAL gColor() AS LONG


' *******************************************************************************************
' START of the helios section
' *******************************************************************************************
%RAND_MAX  = 32767

MACRO PI   = 3.14159265359
MACRO PIx2 = 6.28318530718

TYPE TrsVec
    X          AS SINGLE
    Y          AS SINGLE
    Z          AS SINGLE
END TYPE

TYPE TrsRgb
    R          AS SINGLE
    G          AS SINGLE
    B          AS SINGLE
END TYPE

TYPE TrsQuat
    X          AS SINGLE
    Y          AS SINGLE
    Z          AS SINGLE
    W          AS SINGLE
END TYPE

TYPE Temitter
    X          AS SINGLE
    Y          AS SINGLE
    Z          AS SINGLE

    R          AS SINGLE
    G          AS SINGLE
    B          AS SINGLE

    oldposX    AS SINGLE
    oldposY    AS SINGLE
    oldposZ    AS SINGLE

    targetposX AS SINGLE
    targetposY AS SINGLE
    targetposZ AS SINGLE
END TYPE

TYPE Tattracter
    X          AS SINGLE
    Y          AS SINGLE
    Z          AS SINGLE

    R          AS SINGLE
    G          AS SINGLE
    B          AS SINGLE

    oldposX    AS SINGLE
    oldposY    AS SINGLE
    oldposZ    AS SINGLE

    targetposX AS SINGLE
    targetposY AS SINGLE
    targetposZ AS SINGLE
END TYPE

TYPE Tion
    X          AS SINGLE
    Y          AS SINGLE
    Z          AS SINGLE

    R          AS SINGLE
    G          AS SINGLE
    B          AS SINGLE

    iSize      AS SINGLE
    iSpeed     AS SINGLE
END TYPE

TYPE TrsMatrix
    m(15) AS SINGLE
END TYPE

GLOBAL newRGB() AS SINGLE
GLOBAL elist() AS Temitter
GLOBAL alist() AS Tattracter
GLOBAL ilist() AS Tion
GLOBAL billboardMat() AS SINGLE

GLOBAL g_nIons, g_nSize, g_nEmitters, g_nAttracters, g_nSpeed, g_nCameraSpeed AS LONG
GLOBAL g_rFrameTime AS SINGLE

TYPE rsTimer
  elapsed_time            AS SINGLE '// Time since last call to tick()
  waited_time             AS SINGLE '// Time waited so far by wait()
  wait_function_overhead  AS SINGLE
  highResCounterSupported AS LONG
  freq                    AS SINGLE '// high frequency system counts per second
  curr                    AS QUAD
  prev                    AS QUAD
  lowResCurr              AS DWORD  '// for low res timer if high res is unavailable
  lowResPrev              AS DWORD  '// for low res timer if high res is unavailable
END TYPE
GLOBAL rsT AS rsTimer
DECLARE SUB apiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS DWORD)
DECLARE FUNCTION TimeGetTime LIB "WINMM.DLL" ALIAS "timeGetTime" () AS DWORD
DECLARE FUNCTION QueryPerformanceFrequency LIB "KERNEL32.DLL" ALIAS "QueryPerformanceFrequency" (lpFrequency AS QUAD) AS LONG
DECLARE FUNCTION QueryPerformanceCounter LIB "KERNEL32.DLL" ALIAS "QueryPerformanceCounter" (lpPerformanceCount AS QUAD) AS LONG
SUB TrsTimer()
    rsT.elapsed_time = 0.0
    rsT.waited_time = 0.0
    rsT.wait_function_overhead = 0.0
    '// init high- and low-res timers
    LOCAL nQuad1 AS QUAD
    rsT.highResCounterSupported = QueryPerformanceFrequency(nQuad1)
    rsT.freq = 1.0 / LO(LONG, nQuad1)
    apiSleep(1) ' // make Sleep() and timeGetTime() more accurate
    '// get first tick for high- and low-res timers
    QueryPerformanceCounter(nQuad1)
    rsT.curr = LO(LONG, nQuad1)
    rsT.lowResCurr = timeGetTime()
END SUB

'// return time elapsed since last call to tick()
FUNCTION TrsTick() AS SINGLE
    IF rsT.highResCounterSupported THEN
       rsT.prev = rsT.curr
       LOCAL nQuad1 AS QUAD
       QueryPerformanceCounter(nQuad1)
       rsT.curr = LO(LONG, nQuad1)
       IF rsT.curr >= rsT.prev THEN rsT.elapsed_time = (rsT.curr - rsT.prev) * rsT.freq
    ELSE
       rsT.lowResPrev = rsT.lowResCurr
       rsT.lowResCurr = timeGetTime()
       IF rsT.lowResCurr >= rsT.lowResPrev THEN rsT.elapsed_time = (rsT.lowResCurr - rsT.lowResPrev) * 0.001!
    END IF
    FUNCTION = rsT.elapsed_time
END FUNCTION

FUNCTION rsRandf(BYVAL x AS SINGLE) AS SINGLE
    'return x * (float(rand()) / float(RAND_MAX));
    FUNCTION = x * (RND(0, %RAND_MAX) / %RAND_MAX)
END FUNCTION

FUNCTION rsRandi(BYVAL x AS LONG) AS LONG
    'return rand() % x;
    FUNCTION = RND(0, %RAND_MAX) MOD x
END FUNCTION

SUB emitter_settargetpos(BYVAL i AS LONG, BYVAL x AS SINGLE, y AS SINGLE, z AS SINGLE)
    elist(i).oldposX = elist(i).X
    elist(i).oldposY = elist(i).Y
    elist(i).oldposZ = elist(i).Z
    elist(i).targetposX = x
    elist(i).targetposY = y
    elist(i).targetposZ = z
END SUB

SUB emitter_interppos(BYVAL i AS LONG, BYVAL n AS SINGLE)
    'pPos = oldpos * (1.0f - n) + targetpos * n
    elist(i).X = elist(i).oldposX * (1.0! - n) + elist(i).targetposX * n
    elist(i).Y = elist(i).oldposY * (1.0! - n) + elist(i).targetposY * n
    elist(i).Z = elist(i).oldposZ * (1.0! - n) + elist(i).targetposZ * n
END SUB

SUB emitter_update(BYVAL i AS LONG)
END SUB

SUB attracter_settargetpos(BYVAL i AS LONG, BYVAL x AS SINGLE, y AS SINGLE, z AS SINGLE)
    alist(i).oldposX = alist(i).X
    alist(i).oldposY = alist(i).Y
    alist(i).oldposZ = alist(i).Z
    alist(i).targetposX = x
    alist(i).targetposY = y
    alist(i).targetposZ = z
END SUB

SUB attracter_interppos(BYVAL i AS LONG, BYVAL n AS SINGLE)
    'pPos = oldpos * (1.0f - n) + targetpos * n
    alist(i).X = alist(i).oldposX * (1.0! - n) + alist(i).targetposX * n
    alist(i).Y = alist(i).oldposY * (1.0! - n) + alist(i).targetposY * n
    alist(i).Z = alist(i).oldposZ * (1.0! - n) + alist(i).targetposZ * n
END SUB

SUB attracter_update(BYVAL i AS LONG)
END SUB

MACRO RS_EPSILON = 0.000001!
SUB quat_set(quat AS TrsQuat, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE, BYVAL w AS SINGLE)
    quat.X = x
    quat.Y = y
    quat.Z = z
    quat.W = w
END SUB

SUB quat_make(quat AS TrsQuat, BYVAL a AS SINGLE, v AS TrsVec)
    IF A < RS_EPSILON AND A > -RS_EPSILON THEN
       quat.X = 0.0!
       quat.Y = 0.0!
       quat.Z = 0.0!
       quat.W = 1.0!
    ELSE
       A *= 0.5!
       LOCAL sintheta AS SINGLE
       sintheta = SIN(A)
       quat.X = sintheta * v.X
       quat.Y = sintheta * v.Y
       quat.Z = sintheta * v.Z
       quat.W = COS(A)
    END IF
END SUB

SUB quat_preMult(quatDest AS TrsQuat, quatSrce AS TrsQuat)
    LOCAL rX, rY, rZ, rW AS SINGLE

    rX = quatDest.X
    rY = quatDest.Y
    rZ = quatDest.Z
    rW = quatDest.W

    quatDest.X = rW * quatSrce.X + quatSrce.W * rX + rY * quatSrce.Z - quatSrce.Y * rZ
    quatDest.Y = rW * quatSrce.Y + quatSrce.W * rY + rZ * quatSrce.X - quatSrce.Z * rX
    quatDest.Z = rW * quatSrce.Z + quatSrce.W * rZ + rX * quatSrce.Y - quatSrce.X * rY
    quatDest.W = rW * quatSrce.W - rX * quatSrce.X - rY * quatSrce.Y - rZ * quatSrce.Z
END SUB

SUB identity(M AS TrsMatrix)
    M.m(0) = 1.0!
    M.m(1) = 0.0!
    M.m(2) = 0.0!
    M.m(3) = 0.0!
    M.m(4) = 0.0!
    M.m(5) = 1.0!
    M.m(6) = 0.0!
    M.m(7) = 0.0!
    M.m(8) = 0.0!
    M.m(9) = 0.0!
    M.m(10) = 1.0!
    M.m(11) = 0.0!
    M.m(12) = 0.0!
    M.m(13) = 0.0!
    M.m(14) = 0.0!
    M.m(15) = 1.0!
END SUB

SUB mat_fromQuat(M AS TrsMatrix, Q AS TrsQuat)
    LOCAL s, xs, ys, zs, wx, wy, wz, xx, xy, xz, yy, yz, zz AS SINGLE
    '// must have an axis
    IF (Q.X = 0.0! AND Q.Y = 0.0! AND Q.Z = 0.0!) THEN
       identity(m)
    ELSE
       s = 2.0 / (Q.X * Q.X + Q.Y * Q.Y + Q.Z * Q.Z + Q.W * Q.W)
       xs = Q.X * s
       ys = Q.Y * s
       zs = Q.Z * s
       wx = Q.W * xs
       wy = Q.W * ys
       wz = Q.W * zs
       xx = Q.X * xs
       xy = Q.X * ys
       xz = Q.X * zs
       yy = Q.Y * ys
       yz = Q.Y * zs
       zz = Q.Z * zs

       M.m(0) = 1.0! - yy - zz
       M.m(1) = xy + wz
       M.m(2) = xz - wy
       M.m(3) = 0.0!
       M.m(4) = xy - wz
       M.m(5) = 1.0! - xx - zz
       M.m(6) = yz + wx
       M.m(7) = 0.0!
       M.m(8) = xz + wy
       M.m(9) = yz - wx
       M.m(10) = 1.0! - xx - yy
       M.m(11) = 0.0!
       M.m(12) = 0.0!
       M.m(13) = 0.0!
       M.m(14) = 0.0!
       M.m(15) = 1.0!
    END IF
END SUB

SUB hsl2rgb(BYVAL h AS SINGLE, BYVAL s AS SINGLE, BYVAL l AS SINGLE, r AS SINGLE, g AS SINGLE, b AS SINGLE)
    '// hue influence
    h =  h MOD 1.0!
    IF (h < 0.166667) THEN '// full red, some green
       r = 1.0
       g = h * 6.0!
       b = 0.0
    ELSE
       IF (h < 0.5) THEN '// full green
          g = 1.0
          IF (h < 0.333333) THEN '// some red
             r = 1.0! - ((h - 0.166667!) * 6.0!)
             b = 0.0
          ELSE '// some blue
             b = (h - 0.333333!) * 6.0!
             r = 0.0
          END IF
       ELSE
          IF (h < 0.833333) THEN '// full blue
             b = 1.0
             IF (h < 0.666667) THEN '// some green
                g = 1.0! - ((h - 0.5!) * 6.0!)
                r = 0.0
             ELSE '// some red
                r = (h - 0.666667!) * 6.0!
                g = 0.0
             END IF
          ELSE '// full red, some blue
             r = 1.0
             b = 1.0! - ((h - 0.833333!) * 6.0!)
             g = 0.0
          END IF
       END IF
    END IF

    '// saturation influence
    r = 1.0! - (s * (1.0! - r))
    g = 1.0! - (s * (1.0! - g))
    b = 1.0! - (s * (1.0! - b))

    '// luminosity influence
    r *= l
    g *= l
    b *= l
END SUB

SUB ion_start(BYVAL nIon AS LONG)
    LOCAL i AS LONG, offset AS SINGLE
    i = rsRandi(g_nEmitters - 1)
    'iPos = elist(i).iPos
    ilist(nIon).X = elist(i).X
    ilist(nIon).Y = elist(i).Y
    ilist(nIon).Z = elist(i).Z

    offset = g_rFrameTime * ilist(nIon).iSpeed
    SELECT CASE LONG rsRandi(13)
    CASE 0
         ilist(nIon).X += offset
    CASE 1
         ilist(nIon).X -= offset
    CASE 2
         ilist(nIon).Y += offset
    CASE 3
         ilist(nIon).Y -= offset
    CASE 4
         ilist(nIon).Z += offset
    CASE 5
         ilist(nIon).Z -= offset
    CASE 6
         ilist(nIon).X += offset
         ilist(nIon).Y += offset
         ilist(nIon).Z += offset
    CASE 7
         ilist(nIon).X -= offset
         ilist(nIon).Y += offset
         ilist(nIon).Z += offset
    CASE 8
         ilist(nIon).X += offset
         ilist(nIon).Y -= offset
         ilist(nIon).Z += offset
    CASE 9
         ilist(nIon).X -= offset
         ilist(nIon).Y -= offset
         ilist(nIon).Z += offset
    CASE 10
         ilist(nIon).X += offset
         ilist(nIon).Y += offset
         ilist(nIon).Z -= offset
    CASE 11
         ilist(nIon).X -= offset
         ilist(nIon).Y += offset
         ilist(nIon).Z -= offset
    CASE 12
         ilist(nIon).X += offset
         ilist(nIon).Y -= offset
         ilist(nIon).Z -= offset
    CASE 13
         ilist(nIon).X -= offset
         ilist(nIon).Y -= offset
         ilist(nIon).Z -= offset
    END SELECT

    ilist(nIon).R = newRgb(0)
    ilist(nIon).G = newRgb(1)
    ilist(nIon).B = newRgb(2)

END SUB

FUNCTION normalize(v AS TrsVec) AS SINGLE
    LOCAL length AS SINGLE
    length = SQR(v.X * v.X + v.Y * v.Y + v.Z * v.Z)
    IF (length = 0.0!) THEN
       v.Y = 1.0!
    ELSE
       LOCAL normalizer AS SINGLE
       normalizer = 1.0! / length
       v.X *= normalizer
       v.Y *= normalizer
       v.Z *= normalizer
    END IF
    FUNCTION = length
END FUNCTION

SUB ion_update(BYVAL nIon AS LONG)
    LOCAL i, startOver AS LONG

    STATIC startOverDistance AS SINGLE
    STATIC force, tempvec AS TrsVec
    STATIC length, temp AS SINGLE

    force.X = 0.0!: force.Y = 0.0!: force.Z = 0.0!

    FOR i = 0 TO g_nEmitters - 1
        'tempvec = iPos - elist(i).iPos
        tempvec.X = ilist(nIon).X - elist(i).X
        tempvec.Y = ilist(nIon).Y - elist(i).Y
        tempvec.Z = ilist(nIon).Z - elist(i).Z
        length = normalize(tempvec)
        IF (length > 11000.0!) THEN startOver = 1
        IF (length <= 1.0!) THEN
           temp = 1.0!
        ELSE
           temp = 1.0! / length
        END IF
        'tempvec *= temp
        tempvec.X *= temp
        tempvec.Y *= temp
        tempvec.Z *= temp
       'force += tempvec
        force.X += tempvec.X
        force.Y += tempvec.Y
        force.Z += tempvec.Z
    NEXT
    startOverDistance = ilist(nIon).iSpeed * g_rFrameTime

    FOR i = 0 TO g_nAttracters - 1
        'tempvec = alist(i).iPos - iPos
        tempvec.X = alist(i).X - ilist(nIon).X
        tempvec.Y = alist(i).Y - ilist(nIon).Y
        tempvec.Z = alist(i).Z - ilist(nIon).Z
        length = normalize(tempvec)
        IF (length < startOverDistance) THEN startOver = 1
        IF (length <= 1.0!) THEN
           temp = 1.0!
        ELSE
           temp = 1.0! / length
        END IF
        'tempvec *= temp
        tempvec.X *= temp
        tempvec.Y *= temp
        tempvec.Z *= temp
        'force += tempvec
        force.X += tempvec.X
        force.Y += tempvec.Y
        force.Z += tempvec.Z
    NEXT
    '// Start this ion at an emitter if it gets too close to an attracter
    '// or too far from an emitter
    IF (startOver) THEN
       ion_start(nIon)
    ELSE
       normalize(force)
       'iPos += (force * g_rFrameTime * iSpeed)
       LOCAL offset AS SINGLE
       offset = g_rFrameTime * ilist(nIon).iSpeed
       ilist(nIon).X += force.X * offset
       ilist(nIon).Y += force.Y * offset
       ilist(nIon).Z += force.Z * offset
    END IF

END SUB

SUB ion_draw(BYVAL nIon AS LONG, BYVAL cPulse AS SINGLE)
    LOCAL x, y, z, p AS SINGLE
    x = ilist(nIon).X * billboardMat(0) + ilist(nIon).Y * billboardMat(4) + ilist(nIon).Z * billboardMat(8)
    y = ilist(nIon).X * billboardMat(1) + ilist(nIon).Y * billboardMat(5) + ilist(nIon).Z * billboardMat(9)
    z = ilist(nIon).X * billboardMat(2) + ilist(nIon).Y * billboardMat(6) + ilist(nIon).Z * billboardMat(10)
    glColor3f(ilist(nIon).R, ilist(nIon).G, ilist(nIon).B)
    glPushMatrix()
       glTranslatef(x, y, z)
       p = (cPulse * ilist(nIon).iSize) * 1.5
       glScalef(p, p, p)
       'glScalef(ilist(nIon).iSize, ilist(nIon).iSize, ilist(nIon).iSize)
       glCallList(1)
    glPopMatrix()
END SUB

SUB setTargets(BYVAL whichTarget AS LONG)

    LOCAL i AS LONG, rChange, rPosition, rHeight, rAngle, rCosAngle, rSinAngle AS SINGLE

    SELECT CASE LONG whichTarget
    CASE 0 '// random
         FOR i = 0 TO g_nEmitters - 1
             emitter_settargetpos(i, rsRandf(1000.0!) - 500.0!, rsRandf(1000.0!) - 500.0!, rsRandf(1000.0!) - 500.0!)
         NEXT
         FOR i = 0 TO g_nAttracters - 1
             attracter_settargetpos(i, rsRandf(1000.0!) - 500.0!, rsRandf(1000.0!) - 500.0!, rsRandf(1000.0!) - 500.0!)
         NEXT

    CASE 1 '// line (all emitters on one side, all attracters on the other)
         rPosition = -500.0!
         rChange = 1000.0! / (g_nEmitters + g_nAttracters - 1)
         FOR i = 0 TO g_nEmitters - 1
             emitter_settargetpos(i, rPosition, rPosition * 0.5!, 0.0!)
             rPosition += rChange
         NEXT
         FOR i = 0 TO g_nAttracters - 1
             attracter_settargetpos(i, rPosition, rPosition * 0.5!, 0.0!)
             rPosition += rChange
         NEXT

    CASE 2 '// line (emitters and attracters staggered)
         IF  (g_nEmitters > g_nAttracters) THEN
            rChange = 1000.0! / (g_nEmitters * 2 - 1)
         ELSE
            rChange = 1000.0! / (g_nAttracters * 2 - 1)
         END IF
         rPosition = -500.0!
         FOR i = 0 TO g_nEmitters - 1
             emitter_settargetpos(i, rPosition, rPosition * 0.5!, 0.0!)
             rPosition += rChange * 2.0!
         NEXT
         rPosition = -500.0! + rChange
         FOR i = 0 TO g_nAttracters - 1
             attracter_settargetpos(i, rPosition, rPosition * 0.5!, 0.0!)
             rPosition += rChange * 2.0!
         NEXT

    CASE 3 '// 2 lines (parallel)
         rChange = 1000.0! / (g_nEmitters * 2 - 1)
         rPosition = -500.0!
         rHeight = -525.0! + (g_nEmitters * 25)
         FOR i = 0 TO g_nEmitters - 1
             emitter_settargetpos(i, rPosition, rHeight, -50.0!)
             rPosition += rChange * 2.0!
         NEXT
         rChange = 1000.0! / (g_nAttracters * 2 - 1)
         rPosition = -500.0!
         rHeight = 525.0! - (g_nAttracters * 25)
         FOR i = 0 TO g_nAttracters - 1
             attracter_settargetpos(i, rPosition, rHeight, 50.0!)
             rPosition += rChange * 2.0!
         NEXT

    CASE 4 '// 2 lines (skewed)
         rChange = 1000.0! / (g_nEmitters * 2 - 1)
         rPosition = -500.0!
         rHeight = -525.0! + (g_nEmitters * 25)
         FOR i = 0 TO g_nEmitters - 1
             emitter_settargetpos(i, rPosition, rHeight, 0.0!)
             rPosition += rChange * 2.0!
         NEXT
         rChange = 1000.0! / (g_nAttracters * 2 - 1)
         rPosition = -500.0!
         rHeight = 525.0! - (g_nAttracters * 25)
         FOR i = 0 TO g_nAttracters - 1
             attracter_settargetpos(i, 10.0!, rHeight, rPosition)
             rPosition += rChange * 2.0!
         NEXT

    CASE 5 '// random distribution across a plane
         FOR i = 0 TO g_nEmitters - 1
             emitter_settargetpos(i, rsRandf(1000.0!) - 500.0!, 0.0!, rsRandf(1000.0!) - 500.0!)
         NEXT
         FOR i = 0 TO g_nAttracters - 1
             attracter_settargetpos(i, rsRandf(1000.0!) - 500.0!, 0.0!, rsRandf(1000.0!) - 500.0!)
         NEXT

    CASE 6 '// random distribution across 2 planes
         rHeight = -525.0! + (g_nEmitters * 25)
         FOR i = 0 TO g_nEmitters - 1
             emitter_settargetpos(i, rsRandf(1000.0!) - 500.0!, rHeight, rsRandf(1000.0!) - 500.0!)
         NEXT
         rHeight = 525.0! - (g_nAttracters * 25)
         FOR i = 0 TO g_nAttracters - 1
             attracter_settargetpos(i, rsRandf(1000.0!) - 500.0!, rHeight, rsRandf(1000.0!) - 500.0!)
         NEXT

    CASE 7 '// 2 rings (1 inside and 1 outside)
         rAngle = 0.5!
         rChange = PIx2 / (g_nEmitters)
         FOR i = 0 TO g_nEmitters - 1
             rAngle += rChange
             rCosAngle = COS(rAngle) * 200.0!
             rSinAngle = SIN(rAngle) * 200.0!
             emitter_settargetpos(i, rCosAngle, rSinAngle, 0.0!)
         NEXT
         rAngle = 1.5!
         rChange = PIx2 / (g_nAttracters)
         FOR i = 0 TO g_nAttracters - 1
             rAngle += rChange
             rCosAngle = COS(rAngle) * 500.0!
             rSinAngle = SIN(rAngle) * 500.0!
             attracter_settargetpos(i, rCosAngle, rSinAngle, 0.0!)
         NEXT

    CASE 8 '// ring (all emitters on one side, all attracters on the other)
         rAngle = 0.5!
         rChange = PIx2 / (g_nEmitters + g_nAttracters)
         FOR i = 0 TO g_nEmitters - 1
             rAngle += rChange
             rCosAngle = COS(rAngle) * 500.0!
             rSinAngle = SIN(rAngle) * 500.0!
             emitter_settargetpos(i, rCosAngle, rSinAngle, 0.0!)
         NEXT
         FOR i = 0 TO g_nAttracters - 1
             rAngle += rChange
             rCosAngle = COS(rAngle) * 500.0!
             rSinAngle = SIN(rAngle) * 500.0!
             attracter_settargetpos(i, rCosAngle, rSinAngle, 0.0!)
         NEXT

    CASE 9 '// ring (emitters and attracters staggered)
         IF (g_nEmitters > g_nAttracters) THEN
            rChange = PIx2 / (g_nEmitters * 2)
         ELSE
            rChange = PIx2 / (g_nAttracters * 2)
         END IF
         rAngle = 0.5
         FOR i = 0 TO g_nEmitters - 1
             rCosAngle = COS(rAngle) * 500.0!
             rSinAngle = SIN(rAngle) * 500.0!
             emitter_settargetpos(i, rCosAngle, rSinAngle, 0.0!)
             rAngle += rChange * 2.0!
         NEXT
         rAngle = 0.5! + rChange
         FOR i = 0 TO g_nAttracters - 1
             rCosAngle = COS(rAngle) * 500.0!
             rSinAngle = SIN(rAngle) * 500.0!
             attracter_settargetpos(i, rCosAngle, rSinAngle, 0.0!)
             rAngle += rChange * 2.0!
         NEXT

    CASE 10 '// 2 points
         FOR i = 0 TO g_nEmitters - 1
             emitter_settargetpos(i, 500.0!, 100.0!, 50.0!)
         NEXT
         FOR i = 0 TO g_nAttracters - 1
             attracter_settargetpos(i, -500.0!, -100.0!, -50.0!)
         NEXT

    END SELECT
END SUB
' *******************************************************************************************
' END of the Helios section
' *******************************************************************************************

SUB InitObject()
    LOCAL i AS LONG

    Randomize(36000)'TIMER)

    g_nIons = 150
    g_nSize = 20
    g_nEmitters = 6
    g_nAttracters = 6
    g_nSpeed = 8
    g_nCameraSpeed = 5

    DIM newRgb(2) AS SINGLE
    DIM billboardMat(15) AS SINGLE

    REDIM elist(g_nEmitters - 1) AS Temitter
    FOR i = 0 TO g_nEmitters - 1
        elist(i).X = rsRandf(1000.0!) - 500.0!
        elist(i).Y = rsRandf(1000.0!) - 500.0!
        elist(i).Z = rsRandf(1000.0!) - 500.0!
    NEXT

    REDIM alist(g_nAttracters - 1) AS Tattracter
    FOR i = 0 TO g_nAttracters - 1
        alist(i).X = rsRandf(1000.0!) - 500.0!
        alist(i).Y = rsRandf(1000.0!) - 500.0!
        alist(i).Z = rsRandf(1000.0!) - 500.0!
    NEXT

    REDIM ilist(g_nIons - 1) AS Tion
    LOCAL rTemp AS SINGLE
    FOR I = 0 TO g_nIons - 1
        ilist(I).X = 0.0!
        ilist(I).Y = 0.0!
        ilist(I).Z = 0.0!
        ilist(I).R = 0.0!
        ilist(I).G = 0.0!
        ilist(I).B = 0.0!
        rTemp =  rsRandf(2.0!) + 0.4!
        ilist(I).iSize  = g_nSize * rTemp
        iList(I).iSpeed = g_nSpeed * 12.0! / rTemp
    NEXT

    TrsTimer()

END SUB

FUNCTION BBProc ALIAS "BBProc" (BYREF BBP AS BBPLUGIN) EXPORT AS LONG

    LOCAL nRet, x, y, Msg AS LONG, rc AS RECT
    LOCAL rAspect AS SINGLE

    nRet = %BBP_SUCCESS
    SELECT CASE LONG BBP.Msg
    CASE %BBP_RENDER

         LOCAL i AS LONG
         STATIC nInitDone, nIonsReleased AS LONG, rReleaseTime, rTmp AS SINGLE

         LOCAL nValue, nLValue, nRValue AS LONG, cPulse, Pulse AS SINGLE

         nLValue = (BBP.Lpeak / 700)
         nRValue = (BBP.Rpeak / 768)
         nValue = MAX&(nLValue, nRValue)
         Pulse = nValue / 14
         cPulse = Pulse / 2 ' 4

         g_rFrameTime = TrsTick()

'        // We overwrite the global variable to smooth the camera movment based on the music pulse.
         g_nSpeed = 10 + (Pulse * 10)

         '// Camera movements
         '// first do translation (distance from center)
         STATIC oldCameraDistance, cameraDistance, targetCameraDistance, preCameraInterp, cameraInterp AS SINGLE
         IF nInitDone = 0 THEN
            targetCameraDistance = -1000.0!
            preCameraInterp = PI
         END IF
         preCameraInterp += g_nCameraSpeed * g_rFrameTime * 0.01!
         cameraInterp = 0.5! - (0.5! * COS(preCameraInterp))
         cameraDistance = -1300 ' (1.0! - cameraInterp) * oldCameraDistance + cameraInterp * targetCameraDistance
         IF (preCameraInterp >= PI) THEN
            oldCameraDistance = targetCameraDistance
            targetCameraDistance = -rsRandf(1300.0!) - 200.0!
            preCameraInterp = 0.0!
         END IF
         glMatrixMode(%GL_MODELVIEW)

         glLoadIdentity()

         glTranslatef(0.0, 0.0, cameraDistance)

         '// Do rotation
         DIM radialVel AS STATIC TrsVec: IF nInitDone = 0 THEN radialVel.X = 0.0!: radialVel.Y = 0.0!: radialVel.Z = 0.0!
         DIM targetRadialVel AS STATIC TrsVec: IF nInitDone = 0 THEN targetRadialVel = radialVel
         DIM rotQuat AS STATIC TrsQuat: IF nInitDone = 0 THEN quat_set(rotQuat, 0.0!, 0.0!, 0.0!, 1.0!)
         LOCAL radialVelDiff AS TrsVec
         radialVelDiff.X = targetRadialVel.X - radialVel.X
         radialVelDiff.Y = targetRadialVel.Y - radialVel.Y
         radialVelDiff.Z = targetRadialVel.Z - radialVel.Z
         LOCAL changeRemaining AS SINGLE
         changeRemaining = normalize(radialVelDiff)
         LOCAL change AS SINGLE
         change = g_nCameraSpeed * 0.0002! * g_rFrameTime
         IF (changeRemaining > change) THEN
            radialVelDiff.X *= change
            radialVelDiff.Y *= change
            radialVelDiff.Z *= change
            radialVel.X += radialVelDiff.X
            radialVel.Y += radialVelDiff.Y
            radialVel.Z += radialVelDiff.Z
         ELSE
            radialVel = targetRadialVel
            IF (rsRandi(2)) THEN
               targetRadialVel.X = rsRandf(1.0!): targetRadialVel.Y = rsRandf(1.0!): targetRadialVel.Z = rsRandf(1.0!)
               normalize(targetRadialVel)
               rTmp = g_nCameraSpeed * rsRandf(0.002!)
               targetRadialVel.X *= rTmp
               targetRadialVel.Y *= rTmp
               targetRadialVel.Z *= rTmp
            ELSE
               targetRadialVel.X = 0.0!
               targetRadialVel.Y = 0.0!
               targetRadialVel.Z = 0.0!
            END IF
         END IF
         DIM tempRadialVel AS TrsVec
         tempRadialVel = radialVel
         LOCAL rAngle AS SINGLE
         rAngle = normalize(tempRadialVel)
         DIM radialQuat AS TrsQuat
         quat_make(radialQuat, rAngle, tempRadialVel)
         'rotQuat.preMult(radialQuat);
         quat_preMult(rotQuat, radialQuat)
         DIM rotMat AS TrsMatrix
         mat_fromQuat(rotMat, rotQuat)

         '// Make billboard matrix for rotating particles when they are drawn
         MoveMemory(BYVAL VARPTR(billboardMat(0)), BYVAL VARPTR(rotmat), 64)

         '// Calculate new color
         DIM oldHsl AS STATIC TrsRgb
         DIM newHsl AS STATIC TrsRgb
         DIM targetHsl AS STATIC TrsRgb
         STATIC colorInterp, colorChange AS SINGLE
         IF nInitDone = 0 THEN
            newHsl.R = 1.0!: newHsl.G = 1.0!: newHsl.B = 1.0!
            colorInterp = 1.0!
         END IF
         colorInterp += g_rFrameTime * colorChange
         IF (colorInterp >= 1.0!) THEN
            IF (NOT rsRandi(3) AND g_nIons > 99) THEN  '// change color suddenly
               newHsl.R = rsRandf(1.0!)
               newHsl.G = 1.0! - (rsRandf(1.0!) * rsRandf(1.0!))
               newHsl.B = 1.0!
            END IF
            oldHsl = newHsl
            targetHsl.R = rsRandf(1.0!)
            targetHsl.G = 1.0! - (rsRandf(1.0!) * rsRandf(1.0!))
            targetHsl.B = 1.0!
            colorInterp = 0.0!
            '// amount by which to change colorInterp each second
            colorChange = rsRandf(0.005! * g_nSpeed) + (0.002! * g_nSpeed)
         ELSE
            LOCAL diff AS SINGLE
            diff = targetHsl.R - oldHsl.R
            IF (diff < -0.5! OR (diff > 0.0! AND diff < 0.5!)) THEN
               newHsl.R = oldHsl.R + colorInterp * diff
            ELSE
               newHsl.R = oldHsl.R - colorInterp * diff
            END IF
            diff = targetHsl.G - oldHsl.G
            newHsl.G = oldHsl.G + colorInterp * diff
            IF (newHsl.R < 0.0!) THEN newHsl.R += 1.0!
            IF (newHsl.R > 1.0!) THEN newHsl.R -= 1.0!
            hsl2rgb(newHsl.R, newHsl.G, 1.0!, newRgb(0), newRgb(1), newRgb(2))
         END IF

         '// Release ions
         IF (nIonsReleased < g_nIons) THEN
            rReleaseTime -= g_rFrameTime
            WHILE (nIonsReleased < g_nIons AND rReleaseTime <= 0.0!)
               ion_start(nIonsReleased)
               nIonsReleased += 1
               '// all ions released after 2 minutes
               rReleaseTime += 120.0! / (g_nIons)
            WEND
         END IF

         '// Set interpolation value for emitters and attracters
         STATIC rWait, rInterp, rPreinterp, rInterpconst AS SINGLE
         IF rPreinterp = 0 THEN rPreinterp = PI
         IF rInterpconst = 0 THEN rInterpconst = 0.001!
         rWait -= g_rFrameTime
         IF (rWait <= 0.0!) THEN
         '////
         rPreinterp += g_rFrameTime * (g_nSpeed) * rInterpconst
            'rPreinterp += g_rFrameTime * (1500 * Pulse) * rInterpconst
            'rPreinterp += g_rFrameTime * (100 * Pulse) * rInterpconst
            rInterp = 0.5! - (0.5! * COS(rPreinterp))
         END IF
         IF (rPreinterp >= PI) THEN
            '// select new taget points (not the same pattern twice in a row)
            STATIC nNewTarget, nLastTarget AS LONG
            nLastTarget = nNewTarget
            nNewTarget = rsRandi(10)
            IF (nNewTarget = nLastTarget) THEN
               nNewTarget += 1
            END IF

            setTargets(nNewTarget)

            rPreinterp = 0.0!
            rInterp = 0.0!
            rWait = 10.0!  '// pause after forming each new pattern
            rInterpconst = 0.001!
            IF (NOT rsRandi(4)) THEN '// interpolate really fast sometimes
               rInterpconst = 0.1!
            END IF
         END IF

         '// Update particles
         FOR i = LBOUND(elist) TO UBOUND(elist)
             emitter_interppos(i, rInterp)
             emitter_update(i)
         NEXT
         FOR i = LBOUND(alist) TO UBOUND(alist)
             attracter_interppos(i, rInterp)
             attracter_update(i)
         NEXT
         FOR i = LBOUND(ilist) TO nIonsReleased - 1
             ion_update(i)
         NEXT

         '// Draw
         '// clear the screen
         glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

         nInitDone = -1

         '// Draw ions
         glMatrixMode(%GL_MODELVIEW)
         glBlendFunc(%GL_ONE, %GL_ONE)
         glBindTexture(%GL_TEXTURE_2D, mt(0).texture)

         LOCAL sqrPulse AS SINGLE
         sqrPulse = SQR(Pulse)
         FOR i = 0 TO nIonsReleased - 1
             ion_draw(i, sqrPulse)
         NEXT

         '// Draw an object at the emitter / attracter center.
         glPushMatrix()
            quad_draw(Pulse)
         glPopMatrix()


         '// Very important we must reassign BBP.RC to the new BBP.DC
         '// Note: don't use permanent DC, this produce better and smoother display
         wglMakeCurrent(BBP.DC, BBP.RC)

         glFlush()

    CASE %BBP_CREATE
         '// Retrieve plugin details
         BBP.Title    = "Asleep"
         BBP.Author   = "Patrice Terrier"
         BBP.Version  = MAKDWD(1, 0) '// Version 1.0"
         BBP.RenderTo = %BBP_OPENGL  '// or %BBP_GDIPLUS, or %BBP_DIRECTX

    CASE %BBP_INIT
         '// Do your code initialisation there
         InitObject()

         glClearColor(0.0, 0.0, 0.0, 0.0)     '// Black Background
         glDisable(%GL_DEPTH_TEST)
         glEnable(%GL_BLEND)
         glLightModeli(%GL_LIGHT_MODEL_LOCAL_VIEWER, %GL_TRUE)
         glEnable(%GL_NORMALIZE)
         glBlendFunc(%GL_SRC_ALPHA, %GL_ONE)
         glHint(%GL_PERSPECTIVE_CORRECTION_HINT, %GL_NICEST) '//Realy Nice perspective calculations
        
         glEnable(%GL_TEXTURE_2D)             '// Enable Texture Mapping

'        //Load textures
         DIM mt(7) AS BBPTEXTURE, sResource AS STRING
         sResource = $BBP_PLUGIN_FOLDER + "\Texture\"
       
         mt(0).FullName = sResource + "flare0.png":  mt(0).ID = 1: mt(0).Square = 0 ' Particle
       
         mt(1).FullName = sResource + "V1.png": mt(1).ID = 2: mt(1).Square = 0
         mt(2).FullName = sResource + "V2.png": mt(2).ID = 3: mt(2).Square = 0
         mt(3).FullName = sResource + "V3.png": mt(3).ID = 4: mt(3).Square = 0
         mt(4).FullName = sResource + "V4.png": mt(4).ID = 5: mt(4).Square = 0
         mt(5).FullName = sResource + "V5.png": mt(5).ID = 6: mt(5).Square = 0
         mt(6).FullName = sResource + "V6.png": mt(6).ID = 7: mt(6).Square = 0
       
         mt(7).FullName = sResource + "frame.png": mt(7).ID = 8: mt(7).Square = 0

         MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

'        // Initialize the particle display list
         glNewList(1, %GL_COMPILE)
           'glBindTexture(%GL_TEXTURE_2D, mt(0).Texture)
           glBegin(%GL_TRIANGLES)
             glTexCoord2f(0.0!, 0.0!):  glVertex3f(-0.5!, -0.5!, 0.0!)
             glTexCoord2f(1.0!, 0.0!):  glVertex3f(0.5!, -0.5!, 0.0!)
             glTexCoord2f(1.0!, 1.0!):  glVertex3f(0.5!, 0.5!, 0.0!)
             glTexCoord2f(0.0!, 0.0!):  glVertex3f(-0.5!, -0.5!, 0.0!)
             glTexCoord2f(1.0!, 1.0!):  glVertex3f(0.5!, 0.5!, 0.0!)
             glTexCoord2f(0.0!, 1.0!):  glVertex3f(-0.5!, 0.5!, 0.0!)
           glEnd()
         glEndList()

    CASE %BBP_SIZE
         '// The size of the view port has changed.
         GetClientRect(BBP.ParentWindow, rc)

         glMatrixMode(%GL_PROJECTION)
         glLoadIdentity()
         rAspect = 0: IF rc.nBottom THEN rAspect = rc.nRight / rc.nBottom
         gluPerspective(60.0, rAspect, 0.1, 10000.0)
         'glMatrixMode(%GL_MODELVIEW)

    CASE %BBP_KEYBOARD

    CASE %BBP_MOUSE

    CASE %BBP_DESTROY
         '// Free up your resources there
         DestroyTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

         'BBP_DeleteGLFont(UseFont) ' Free up the OpenGL font

    CASE ELSE
        nRet = %BBP_ERROR
    END SELECT

    FUNCTION = nRet
    EXIT FUNCTION

END FUNCTION

SUB DrawQuad(BYVAL x AS SINGLE, BYVAL y AS SINGLE, Byval z AS SINGLE, BYVAL nTexture AS LONG)
   glBindTexture(%GL_TEXTURE_2D, nTexture)
   glBegin(%GL_QUADS)
      glTexCoord2f(0.0, 0.0): CALL glVertex3f(-x,-y, z) ' Bottom Left Of The Texture And Quad
      glTexCoord2f(1.0, 0.0): CALL glVertex3f( x,-y, z) ' Bottom Right Of The Texture And Quad
      glTexCoord2f(1.0, 1.0): CALL glVertex3f( x, y, z) ' Top Right Of The Texture And Quad
      glTexCoord2f(0.0, 1.0): CALL glVertex3f(-x, y, z) ' Top Left Of The Texture And Quad
   glEnd()
END SUB

SUB Quad_Draw(BYVAL Pulse AS LONG)

    LOCAL K AS LONG, x, y, z, sSize, sPulseSize AS SINGLE
    STATIC UseAngle AS SINGLE
    UseAngle += 0.1 + Pulse
    UseAngle = UseAngle MOD 360

'   // The culling section.
    DIM A1(g_nAttracters - 1) AS SINGLE, A2(g_nAttracters - 1) AS LONG
    FOR K = 0 TO g_nAttracters - 1
        A1(K) = alist(K).X * billboardMat(2) + alist(K).Y * billboardMat(6) + alist(K).Z * billboardMat(10)
        A2(K) = K
    NEXT
'   // Sort bazed on the Z-order location.
    ARRAY SORT A1(), TAGARRAY A2()

    FOR K = 0 TO g_nAttracters - 1

        glPushMatrix()
           x = alist(A2(K)).X * billboardMat(0) + alist(A2(K)).Y * billboardMat(4) + alist(A2(K)).Z * billboardMat(8)
           y = alist(A2(K)).X * billboardMat(1) + alist(A2(K)).Y * billboardMat(5) + alist(A2(K)).Z * billboardMat(9)
           z = A1(K)
           glTranslatef(x, y, z)

           CALL glColor4f(0.95, 0.95, 0.95, 0.5)
           sSize = 200

           IF K = g_nAttracters -1 THEN
              IF (A2(K)+1) <> 6 THEN
                 sPulseSize = sSize + (Pulse * 5)
              ELSE
                 sPulseSize = sSize
              END IF
              DrawQuad(sPulseSize, sPulseSize, 0, mt(A2(K)+1).Texture)
              DrawQuad(sSize, sSize, 0, mt(7).Texture)
           ELSE
              IF (A2(K)+1) <> 6 THEN
                 sPulseSize = sSize + (Pulse * 5)
              ELSE
                 sPulseSize = sSize
              END IF
              'glRotatef(UseAngle + (K * 5), 0, 1, 0)
              'DrawQuad(sSize, sSize, 0, mt(1).Texture)
              DrawQuad(sPulseSize, sPulseSize, 0, mt(A2(K)+1).Texture)

           END IF
        glPopMatrix()
    NEXT

END SUB

SUB MakeMultipleTexture (BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG)
    LOCAL mtCount, K, nRet, xSize, ySize, OkDelete AS LONG
    DIM mTex(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mTex()) - LBOUND(mTex()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mTex(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN glDeleteTextures(mtCount, Texture(1))
       glGenTextures(mtCount, Texture(1)): nRet = glGetError()
       IF nRet = 0 THEN
          FOR K = 1 TO mtCount
              REDIM PixelArray(0) AS BYTE
              IF BBP_CreateGLTextureFromFile(mTex(K).FullName, xSize, ySize, PixelArray(), mTex(K).Square) THEN
                 mTex(k).Texture = Texture(K)
                 glBindTexture(%GL_TEXTURE_2D, Texture(K)): nRet = glGetError
                 IF nRet = 0 THEN
                    glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MAG_FILTER, %GL_LINEAR)
                    glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MIN_FILTER, %GL_LINEAR)
                    glTexImage2D(%GL_TEXTURE_2D, 0, 4, xSize&, ySize&, 0, %GL_RGBA, %GL_UNSIGNED_BYTE, PixelArray(0))
                 END IF
              END IF
          NEXT
       END IF
    END IF
END SUB

SUB DestroyTexture(BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG)
    LOCAL K, mtCount, OkDelete AS LONG
    DIM mTex(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mTex()) - LBOUND(mTex()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mTex(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN glDeleteTextures(mtCount, Texture(1))
    END IF
END SUB

